package net.pricefx.common.apibuilder;

import net.pricefx.common.api.chart.SeriesType;

@SuppressWarnings("rawtypes")
public abstract class AbstractAdditionalMeasure<ATTACHEDTO extends ObjectIdentity, T extends AbstractAdditionalMeasure> extends BacklinkBuilder<ATTACHEDTO> {
	
	public AbstractAdditionalMeasure(String instanceId, String classId, ATTACHEDTO parentChartObjectIdentity, IdGenerator idGenerator, Invocations<MethodInvocation> invocations) {
		super(instanceId, classId, parentChartObjectIdentity);
	}

	@SuppressWarnings({ "unchecked" })
	public final T setMeasure(String measure) {

		addInvocation("setMeasure", measure);
		return (T) this;
	}

	@SuppressWarnings({ "unchecked" })
	public final T setType(SeriesType seriesType) {

		addInvocation("setType", seriesType);
		return (T) this;
	}

	@SuppressWarnings({ "unchecked" })
	public final T setOnZAxis(Boolean onZAxis) {

		addInvocation("setOnZAxis", onZAxis);
		return (T) this;
	}
	
	@SuppressWarnings({ "unchecked" })
	public final T withTotal() {

		addInvocation("withTotal");
		return (T) this;
	}

	@SuppressWarnings({ "unchecked" })
	public final T withPerUnit() {
		
		addInvocation("withPerUnit");
		return (T) this;
	}

	@SuppressWarnings({ "unchecked" })
	public final T withPercent() {

		addInvocation("withPercent");
		return (T) this;
	}

	@SuppressWarnings({ "unchecked" })
	public final T withAggregation(String aggregationFunction) {

	    addInvocation("withAggregation", aggregationFunction);
	    return (T) this;
	}

	@SuppressWarnings({ "unchecked" })
	public final T withFormula() {

		addInvocation("withFormula");
		return (T) this;
	}
}