package net.pricefx.formulaengine.scripting.inputbuilder;

import net.pricefx.common.api.InputType;

public abstract class AbstractProductAndCustomerInputBuilder<T extends AbstractProductAndCustomerInputBuilder, VT> extends AbstractInputBuilder<T, VT> {

    protected String attributeName;
    protected String filterFomulaName;
    protected String filterFormulaParam;

    protected AbstractProductAndCustomerInputBuilder(InputBuilderContext builderContext, InputType type, String paramName) {
        super(builderContext, type, paramName);
    }

    public T setAttributeName(String attributeName) {
        this.attributeName = attributeName;
        return (T) this;
    }

    public T setFilterFormulaName(String filterFormulaName) {
        this.filterFomulaName = filterFomulaName;
        return (T) this;
    }

    public T setFilterFormulaParam(String filterFormulaParam) {
        this.filterFormulaParam = filterFormulaParam;
        return (T) this;
    }

}
