package net.pricefx.logic.core.model.holders;

import net.pricefx.logic.core.model.BaseMapNullable;
import net.pricefx.restapiclient.model.BaseMap;

import java.util.List;
import java.util.stream.Collectors;


public class WorkflowHolder extends BaseMapNullable {

    public BaseMap getWorkFlow() {
        return getMapValue("workflow");
    }

    public List<WorkflowStepHolder> getSteps() {
        return ((List<BaseMap>) getWorkFlow().getListValue("steps"))
                .stream()
                .map(step -> new WorkflowStepHolder(step))
                .collect(Collectors.toList());
    }
}
